#!/usr/bin/env perl
use WWW::Mechanize;   # libwww-mechanize-perl 
use LWP::UserAgent;   # libwww-perl
use File::Basename;   # perl-modules
use Digest::MD5 qw(md5 md5_hex md5_base64);


my $GotoBLAS2_login_url='http://www.tacc.utexas.edu/?id=402';
my $config_file='/etc/gotoblas2-helper/gotoblas2-site.conf';
$config_file='gotoblas2-site.conf' if -f 'gotoblas2-site.conf';
my $release_file='/etc/gotoblas2-helper/release';
my $release = "";

sub get_release()
{
    my $fd;
    open $fd,'<', $release_file or return("") ;
    my $rel = <$fd>;
    $rel =~ s/[^0-9\.]//g;
    close($fd);
    return $rel;
}
$release = get_release();

sub config_gotoblas()
{
    my %config_hash = ( username=>'', password=>'', accept=>'no' );
    
    open my $fd,'<',$config_file or die ($config_file);
    while(<$fd>){
	chop($_);
	$_ =~ s/\#.*$//g;
	$_ =~ s/[\t\s]//g;
	my @parms = split (/=/,$_);
	if ( $#parms == 1 ){
	    $config_hash{$parms[0]}=$parms[1];
	}
    }
    close($fd);
    return %config_hash;
}

# read configurartion file
my %def=config_gotoblas();

# Licence Accept
exit(0) if ( $def{'accept'} =~ /^no$/i );

my $mech = WWW::Mechanize->new(agent=>'GotoBLAS2 Debian helper/0.1',
			       cookie_jar => {});

# gotoblas top
$mech->get( $GotoBLAS2_login_url );
die($mech->res()->status_line() . ":" . "Login from.")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );

my $enc_pass = md5_hex($def{'password'});
my %hid = ();
foreach my $form ($mech->forms) {
  foreach my $input ($form->inputs) {
      $hid{$input->name} = $input->value ;
  }
}
my $pass_value = md5_hex($def{'username'} . ":" . $enc_pass . ":" . $hid{'challenge'} );

$mech->submit_form(form_number => 1,
		   fields    =>
		   { user      => $def{'username'},
		     pass      => $pass_value,
		     pid       => $hid{'pid'},
		     challenge => $hid{'challenge'},
		     logintype => $hid{'logintype'},
		     submit    => $hid{'Login'},
		   },
		   );

die($mech->res()->status_line() . ":" . "Auth")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );
die("There was an error with your username or password. see $config_file")
    if ( $mech->content() =~ /Oops/);

# result Here
$mech->follow_link('text_regex' => qr/Accept/i);
die($mech->res()->status_line() . ":" . "Accept")
    unless ( $mech->res()->status_line() =~ /^200 OK/ );

my @links;
my $url_regex = qr/GotoBLAS2-[0-9]+\.[0-9p]+\.tar\.g/;
push(@links,$mech->find_all_links('url_regex' => $url_regex ));

my $targeturl=''; 
my $i = 0;
my $savefilename = 'GotoBLAS2.tar.gz';
my $version = '';

sub vsort($$)
{
    my ($a, $b) = @_;
    my $av = basename($a->url());
    my $bv = basename($b->url());
    $av =~  s/^([^&]+?)&.*$/$1/g;
    $bv =~  s/^([^&]+?)&.*$/$1/g;
    return( $av le $bv )
}

@links = sort vsort @links;

foreach my $h (@links){
    $i++;
    if (( $i == 1 && $def{version} =~ /new/i )||
	( $h->url() =~ /\-$def{version}\.tar.gz/ )){
	$targeturl = $h->url;
	$savefilename = basename($h->url());
	$savefilename =~ s/^([^&]+?)&.*$/$1/g;
        $version = $savefilename;
	$version =~  s/^(.+?)([0-9p\.]+)\.tar\.gz$/$2/g;
    }
}

if ( $targeturl ne '' ){
    if ( $release eq $version ) {
        print $version,"\n";
        exit(0);
    }
    $mech->follow_link(url => $targeturl ) or die();
    if ( $mech->res()->status_line() =~ /^200 OK/ ) {
        open my $fd,'>',$savefilename or die($savefilename);
        print $fd $mech->content();
        close $fd;
        print $version,"\n";
    } else {
        die($mech->res()->status_line() . ":" . $savefilename);
    }

}
exit(0);
